#define tic 0x927C0

#define EN_PIN   4 // Пин включения драйвера
#define STEP_PIN  3 // Пин сигнала шага драйвера (CLC, STEP)
#define DIR_PIN  2 //Пин направления вращения (CW, DIR

volatile uint16_t count; 
volatile unsigned long speed;
volatile bool run;
bool start, dir;

float rpm;

void setup()
{
    pinMode(STEP_PIN , OUTPUT);		
    pinMode(DIR_PIN , OUTPUT);
    pinMode(EN_PIN , OUTPUT);
    
    digitalWrite(DIR_PIN , HIGH);
    
    rpm=100;
    dir=false;
    speed=tic/rpm;
    run=false;
    start=true;
    
    TCCR2A = (1<<WGM21);    
    TCCR2B = (1<<CS20);    
    OCR2A = 0x80; 
    TIMSK2 = (1<<OCIE2A);  
  
    sei (); 
}

void accelerate()
{
  run=true;
  set_pins();
  int i;
  for(i=1;i<rpm;i++)
    {
       speed = tic/(i);
       delay(3);  
    }
  start=false;
}

void set_pins()
{
 if(run) digitalWrite(EN_PIN , LOW);
  else  digitalWrite(EN_PIN , HIGH);
 if(dir) digitalWrite(DIR_PIN , LOW);
  else  digitalWrite(DIR_PIN , HIGH);
}

void calculate()
{
  speed=tic/rpm;	  
}

void loop()
{
     if (start) accelerate();
     calculate();     
     set_pins();
}

ISR (TIMER2_COMPA_vect)
{   
   if (count>0) 
    {
     count--;
     OCR2A = 0x80;
    }
   else 
    {
     digitalWrite(STEP_PIN , HIGH);
     count = speed >> 7;
     OCR2A = speed % 0x80;     
     digitalWrite(STEP_PIN , LOW);	  
    }            				  
}


